/* InfoPanel.h created by znek on Sat 08-Apr-2000 */
/* $Id$
 *
 * $Log$
 */

#import <AppKit/AppKit.h>

@class MKMulleLogoDrawer;

typedef struct
{
   float  scale;
   float  increment;
} mkZoom;


@interface MKInfoPanel : NSObject
{
  IBOutlet NSWindow      *mainWindow;
  IBOutlet NSTextView    *textView;
  IBOutlet NSImageView   *backgroundImageView;
  IBOutlet NSTextField   *headerView;
  IBOutlet NSTextField   *subHeaderView;
  IBOutlet NSTextField   *footerView;
  IBOutlet NSImageView   *iconView;

  NSImage   *bgImage;
  NSImage   *shadeMask;
  NSImage   *alphaMask;

  MKMulleLogoDrawer   *mulleLogo;
  
  NSRect   insideRect;
  NSRect   outsideRect;

  float    hz;
  NSTimer  *timer;

  NSImage  *panelImage;
  NSRect   panelImageRect;
  
  BOOL     useZNeKZoomer;

  mkZoom   *currentZoom;
}


+ (NSString *)nibName;
- (void)activateMainWindow:(id)sender;

- (void)updateImageView;

- (void)startAnimation;
- (void) restartAnimation;
- (void)animate:(NSTimer *)timer;
- (void)computeNewScale;
- (void)computeNewRotation;
- (void) setUseZNeKZoomer:(BOOL) flag;
- (NSImage *)panelImage;
- (void) updateViewsFromCustominfo;
@end
