/* MKLogoView.m created by nat on Wed 12-Apr-2000 */

#import "MKLogoView.h"
#import "NSImage+EPS.h"


@implementation MKLogoView

static NSSize  ratio = { 0.65, 0.65 };
static NSSize  offset = { -150.0 / 0.65, -140 / 0.65 };


- initWithFrame:(NSRect) frame
{
   [super initWithFrame:frame];

   rotator   = [[[NSImage imageNamed:@"ring"] epsImageRep] retain];
   mullerich = [[[NSImage imageNamed:@"mullerich"] epsImageRep] retain];

   if( ! rotator || ! mullerich)
   {
      [self release];
      self = nil;
   }
   [self setBoundsSize:[rotator size]];
   scaling.width = scaling.height = 1.0;

   panelImageRect = NSMakeRect(0,0, 476,260);
   panelImage = [[NSImage allocWithZone:[self zone]] initWithSize:panelImageRect.size];
   return( self);
}


- (void) dealloc
{
   [mullerich release];
   [rotator release];
   [panelImage release];
   [super dealloc];
}

//
// Step #1 draw rotated ring
// Step #2 draw mullerich
//
#warning (nat) should setup clipping properly....

- (void) drawRect:(NSRect) rect
{
//   rect.size = [rotator size];

   [self lockFocus];
   
   PStranslate( rect.size.width / 2, rect.size.height / 2);
   PSscale( scaling.width, scaling.height);
   PSrotate( rotation);
   PStranslate( - rect.size.width / 2, - rect.size.height / 2);
   [rotator draw];
   
   [self unlockFocus];
   
   //
   // position head according to ring
   // 

   PStranslate( rect.size.width / 2, rect.size.height / 2);
   PSscale( scaling.width * ratio.width, scaling.height * ratio.height);
   PStranslate( offset.width, offset.height);
   
   [mullerich draw];
}


- (void) setRotation:(float) value
{
   rotation = value;
}


- (float) rotation
{
   return( rotation);
}

- (void) setScaling:(float) value
{
   scaling.width = scaling.height = value;
}


- (float) scaling
{
   return( scaling.width);
}

- (NSImage *)panelImage
{
  NSRect rect = panelImageRect;
  
  [panelImage lockFocus];
  // clear canvas with that beautiful light gray
  [[NSColor colorWithDeviceWhite:NSLightGray alpha:0.0] set];
  NSRectFill(panelImageRect);

  PStranslate( rect.size.width / 2, rect.size.height / 2);
  PSscale( scaling.width, scaling.height);
  PSrotate( rotation);
  PStranslate( - rect.size.width / 2, - rect.size.height / 2);
  [rotator draw];
  [panelImage unlockFocus];

  [panelImage lockFocus];

  PStranslate( rect.size.width / 2, rect.size.height / 2);
  PSscale( scaling.width * ratio.width, scaling.height * ratio.height);
  PStranslate( offset.width, offset.height);

  [mullerich draw];

  [panelImage unlockFocus];

  return panelImage;
}

@end
