/* NSMulleLogoView.m created by nat on Wed 12-Apr-2000 */
/* $Id$
 *
 * $Log$
 */

#import "MKMulleLogoDrawer.h"
#import "NSImage+EPS.h"


@implementation MKMulleLogoDrawer

static NSSize  ratio = { 0.65, 0.65 };
static NSSize  offset = { -150.0 / 0.65, -140 / 0.65 };


//+ sharedInstance
//{
//   static id   sharedInstance;
//   
//   if( ! sharedInstance)
//      sharedInstance = [[self alloc] init];
//   return( sharedInstance);
//}


- init
{
   [super init];

   rotator   = [[[NSImage imageNamed:@"ring"] epsImageRep] retain];
   mullerich = [[[NSImage imageNamed:@"mullerich"] epsImageRep] retain];

   if( ! rotator || ! mullerich)
   {
      [self release];
      return( nil);
   }
   scaling.width = scaling.height = 1.0;
   
   return( self);
}


- (void) dealloc
{
   [mullerich release];
   [rotator release];
   [super dealloc];
}

//
// Step #1 draw rotated ring
// Step #2 draw mullerich
//
- (void) drawRect:(NSRect) rect
{
   NSAffineTransform   *transform;
   
   [[NSGraphicsContext currentContext] saveGraphicsState];
   
   transform = [NSAffineTransform transform];
   
   [transform translateXBy:rect.size.width / 2
                       yBy:rect.size.height / 2];
   [transform scaleXBy:scaling.width
                   yBy:scaling.height]; 

   [transform rotateByDegrees:rotation];
   [transform translateXBy:- rect.size.width / 2
                       yBy:- rect.size.height / 2];
   [transform concat];
   [rotator draw];
   
   [[NSGraphicsContext currentContext] restoreGraphicsState];
   
   //
   // position head according to ring
   // 
   transform = [NSAffineTransform transform];

   [transform translateXBy:rect.size.width / 2
                       yBy:rect.size.height / 2];
   [transform scaleXBy:scaling.width * ratio.width
                   yBy:scaling.height * ratio.height]; 
   [transform translateXBy:offset.width
                       yBy:offset.height];
   
   [transform concat];
   [mullerich draw];
}


- (void) setRotation:(float) value
{
   rotation = value;
}


- (void) incrementRotation:(float) value
{
   rotation += value;
}


- (float) rotation
{
   return( rotation);
}


- (void) setScaling:(float) value
{
   scaling.width = scaling.height = value;
}


- (void) incrementScaling:(float) value
{
   scaling.width  = scaling.width + value;
   scaling.height = scaling.height + value;
}


- (float) scaling
{
   return( scaling.width);
}


- (NSSize) size
{
   return( [rotator size]);
}

@end
